<?php

namespace Drupal\group_computed_field\Field;

use Drupal\Core\Field\EntityReferenceFieldItemList;
use Drupal\Core\Field\EntityReferenceFieldItemListInterface;
use Drupal\Core\TypedData\ComputedItemListTrait;

/**
 * Class GroupComputedField.
 *
 * A computed field for retrieving an entity's related groups.
 */
class GroupComputedField extends EntityReferenceFieldItemList implements EntityReferenceFieldItemListInterface {
  use ComputedItemListTrait;

  /**
   * {@inheritDoc}
   */
  protected function computeValue() {
    $related_groups = \Drupal::service('group_computed_field.group_entity_type_helper')->getRelatedGroups($this->getEntity());

    foreach ($related_groups as $delta => $value) {
      $this->list[$delta] = $this->createItem($delta, $value);
    }
  }

}
